'''
Created on Jan 13, 2012

@author: Pedro
'''

import networkx as nx

class DB(object):
    '''
    classdocs
    '''


    def __init__(self):
        '''
        Constructor
        '''
        self.db_id = 7
        self.classification_thresh = 0.01#% chance of being random
        self.final_time = 30 #672 
        self.num_random_files = 2
        self.window = 24#*7
        
    def set_db_id(self, db_id):
        self.db_id = db_id
        
    def set_classification_thresh(self, ct):
        self.classification_thresh = ct
        
    def set_num_random_files(self, num_rf):
        self.num_random_files = num_rf
        
    def get_classification_threshold(self):
        return self.classification_thresh
    
    def get_num_random_files(self):
        return self.num_random_files
    
    def get_final_time(self):
        if(self.db_id == 1):
            return 28
        elif(self.db_id == 2):
            return 28 #42
        elif(self.db_id == 8 or self.db_id == 9 or self.db_id == 10):
            return 20
        else:
            return 28
        
    def get_db_name(self):
        if(self.db_id == 1):
            return "Dart"
        elif(self.db_id == 2):
            return "USC"
        elif (self.db_id == 3):
            return "Taxi"
        elif (self.db_id == 4):
            return "UPB"     
        elif (self.db_id == 8):
            return "4Square-NY"
        elif (self.db_id == 9):
            return "4Square-TK"   
        elif (self.db_id == 10):
            return "4Square-SP"   

        else:
            return "SASSY"
    
    def get_graphs_path(self):
        path = "../../Graphs_Data/" + self.get_db_name() + "/"
        return path
    
    def get_rnd_graphs_path(self):
        path = self.get_graphs_path() + "random/"
        return path
    
    def get_classified_graphs_path(self):
        path = self.get_graphs_path() + "classified/"
        return path   
    
    def get_results_graphs_path(self):
        path = self.get_graphs_path() + "results/"
        return path  
    
    def get_aggregated_graph_name(self, time):
        name = "Aggregated" + str(self.window) + "-" + str(time) + ".graph"
        return name
    
    def get_windowed_graph_name(self, time):
        name = "Windowed" + str(self.window) + "-" + str(time) + ".graph"   
        return name
    
    def get_rnd_graph_name(self, seed, time):
        name = "rnd" + self.get_db_name() + "_seed" + str(seed) + "_time" + str(time)
        if(self.db_id == 3):
            name = name + "_window" + str(self.window)
        return name
    
    def get_classified_graph_name(self, class_g):
        name = "classified" + self.get_db_name() + "_class" + str(class_g) + "_threshold" + str(self.classification_thresh) + "_time" + str(self.final_time)
        return name    
    
    def get_results_graph_name(self, class_g):
        name = "results" + self.get_db_name() + "_class" + str(class_g) + "_threshold" + str(self.classification_thresh) + "_time" + str(self.final_time) + ".dat"
        return name  
    
    def get_classification_summary_name(self):
        name = self.get_classified_graphs_path() + "Summary" + self.get_db_name() + "_threshold" + str(self.classification_thresh) + "_time" + str(self.final_time)
        return name
    
    def get_rnd_graph_full_name(self, seed, time):
        name = self.get_rnd_graphs_path() + self.get_rnd_graph_name(seed, time)
        return name
 
    def get_aggregated_graph_full_name(self, time):
        name = self.get_graphs_path() + self.get_aggregated_graph_name(time)
        return name
    
    def get_classified_graph_full_name(self, class_g):
        name = self.get_classified_graphs_path() + self.get_classified_graph_name(class_g)
        return name    
    
    def get_results_graph_full_name(self, class_g):
        name = self.get_results_graphs_path() + self.get_results_graph_name(class_g)
        return name    

   
    def read_aggregated_graph(self, time):
        filename = self.get_aggregated_graph_full_name(time)
        G=nx.read_edgelist(filename, nodetype = int, data=(('per',float),('weight',float),('topct',float),('to',float),('degreei',float),('degreej',float),('count',int),))
        G.graph['time'] = time
        return G
    
    def read_classified_graph(self, class_g):
        filename = self.get_classified_graph_full_name(class_g)
        G=nx.read_edgelist(filename, nodetype = int, data=(('per',float),('weight',float),('topct',float),('to',float),('degreei',float),('degreej',float),('count',int),('class', int),))
        G.graph['time'] = self.final_time
        return G    

    
 
    