package loganalysis;

import org.apache.commons.math.stat.descriptive.DescriptiveStatistics;

public class NodeFeatures {
	
	int id;
	
	public DescriptiveStatistics degree = new DescriptiveStatistics();
	public DescriptiveStatistics closeness = new DescriptiveStatistics();
	public DescriptiveStatistics betweeness = new DescriptiveStatistics();
	public DescriptiveStatistics pageRank = new DescriptiveStatistics();	
	
	
	
	public NodeFeatures(int id) {
		super();
		this.id = id;
	}

	public void addDegree(double value) {
		if(!Double.isNaN(value))
			degree.addValue(value);
	}
	
	public void addCloseness(double value) {
		if(!Double.isNaN(value))
			closeness.addValue(value);
	}	
	
	public void addBetweeness(double value) {
		if(!Double.isNaN(value))
			betweeness.addValue(value);
	}	
	
	public void addPageRank(double value) {
		if(!Double.isNaN(value))
			pageRank.addValue(value);
	}		
	
	
	
	

}
