package main;
 
import java.text.DecimalFormat;

import propagation.ClassesAllowed;
import propagation.PropagationByClassMulticast;
import propagation.PropagationByClassSevere;
import propagation.PropagationSNA;
import propagation.PropagationStartTimes;
import loganalysis.EdgesClassReader;

public class RunScripts {
	
	public static void runGenerateGraphs(int db) throws Exception {
		
		DB.myDB = db;
		
		RunConfig.LOAD_EVENT_G = true;
		RunConfig.LOAD_WINDOWED_G = true;
		RunConfig.LOAD_FULL_G = true;
		RunConfig.SAVE_GRAPH_FILE = true;
		RunConfig.RUN_OVER_TEST_SET = false;
		
		PropagationSNA prop = new PropagationSNA();
		Run net = new Run(DB.getScheduler(), prop);
	}
	
	public static void runMulticastPropagation() throws Exception {
		//propagation multicast
		Run net;
		RunConfig.P_RANDOM = "0.01";
		
		EdgesClassReader ecreader = new EdgesClassReader();
		Integer nodes[] = ecreader.getNodes();
		
		//for(int i= 1287; i<nodes.length; i++) { sem new encounter edges
		//for(int i= 1121; i<nodes.length; i++) {
		for(int i=546; i<nodes.length; i++) { //Dart
		//for(int i=218; i<nodes.length; i++) { //USC
			int node = nodes[i];
		    /*int i=0;
			int node = 162;
			RunConfig.START_TIME_INFECTION = 4282077;*/
			System.out.println("multicast from node: " + node + " i: " + i);
			PropagationByClassMulticast propagation = new PropagationByClassMulticast(node);
			net = new Run(DB.getScheduler(), propagation);
			RunConfig.START_TIME_INFECTION = -1;
		}		
	}
	
	public static void runSeverePropPreviousStartTimes() throws Exception {
		PropagationStartTimes stimes = new PropagationStartTimes();
		int sim=0;
		
		Run net;
		PropagationByClassSevere prop;
		
		while(stimes.hasNextDart()) {
			sim++;
			System.out.println("SIMULATION " + sim);
			RunConfig.P_RANDOM = "0.01";

			DB.myDB = 0;
			System.out.println("DB: " + DB.myDB);
			RunConfig.START_TIME_INFECTION = stimes.nextDart();
			
			ClassesAllowed.forbidAll();
			ClassesAllowed.allowClass(2); 
			//ClassesAllowed.allowClass(4); 
			prop = new PropagationByClassSevere();
			net = new Run(DB.getScheduler(),prop);
			
/*			ClassesAllowed.forbidAll();
			ClassesAllowed.allowClass(3); 
			ClassesAllowed.allowClass(4); 
			prop = new PropagationByClassSevere();
			net = new NetworkAnalyzer(DB.getScheduler(),prop);	
			
			ClassesAllowed.forbidAll();
			ClassesAllowed.allowClass(2); 
			ClassesAllowed.allowClass(3); 
			prop = new PropagationByClassSevere();
			net = new NetworkAnalyzer(DB.getScheduler(),prop);*/
			
			DB.myDB = 4;
			System.out.println("DB: " + DB.myDB);
			RunConfig.START_TIME_INFECTION = stimes.nextUSC();
			
/*			ClassesAllowed.forbidAll();
			ClassesAllowed.allowClass(2); 
			ClassesAllowed.allowClass(3); 
			prop = new PropagationByClassSevere();
			net = new NetworkAnalyzer(DB.getScheduler(),prop);
			*/
			ClassesAllowed.forbidAll();
			ClassesAllowed.allowClass(2); 
			//ClassesAllowed.allowClass(4); 
			prop = new PropagationByClassSevere();
			net = new Run(DB.getScheduler(),prop);			
						
			
			
		}
	}
	
	public static void runSeverePropagation() throws Exception {
		
		Run net;

		PropagationByClassSevere prop;
		
		
   		for(int sim=1; sim<21; sim++) {

			System.out.println("SIMULATION " + sim);
			for(int i=0; i<=4; i=i+4) {
				System.out.println("DB: " + i);
				DB.myDB = i;
				RunConfig.START_TIME_INFECTION = -1;
				
				ClassesAllowed.allowAll();
				prop = new PropagationByClassSevere();
				net = new Run(DB.getScheduler(),prop);
				
				ClassesAllowed.forbidAll();
				ClassesAllowed.allowClass(1); //friends

				
				//RunConfig.P_RANDOM = "0.1";
				//prop = new PropagationByClassSevere();
				//net = new NetworkAnalyzer(DB.getScheduler(),prop);
				RunConfig.P_RANDOM = "0.01";
				prop = new PropagationByClassSevere();
				net = new Run(DB.getScheduler(),prop);
				/*RunConfig.P_RANDOM = "0.001";
				net = new NetworkAnalyzer(DB.getScheduler(),prop);
				RunConfig.P_RANDOM = "0.0001";
				net = new NetworkAnalyzer(DB.getScheduler(),prop);*/
				
				ClassesAllowed.forbidAll();
				ClassesAllowed.allowClass(3); //acquas
				
				//RunConfig.P_RANDOM = "0.1";
				//prop = new PropagationByClassSevere();
				//net = new NetworkAnalyzer(DB.getScheduler(),prop);
				//RunConfig.P_RANDOM = "0.01";
				prop = new PropagationByClassSevere();
				net = new Run(DB.getScheduler(),prop);
/*				RunConfig.P_RANDOM = "0.001";
				net = new NetworkAnalyzer(DB.getScheduler(),prop);
				RunConfig.P_RANDOM = "0.0001";
				net = new NetworkAnalyzer(DB.getScheduler(),prop);	*/	
				
				ClassesAllowed.forbidAll();
				ClassesAllowed.allowClass(4);
				
				prop = new PropagationByClassSevere();
				net = new Run(DB.getScheduler(),prop);
				
				ClassesAllowed.forbidAll();
				ClassesAllowed.allowClass(1);
				ClassesAllowed.allowClass(2);
				
				prop = new PropagationByClassSevere();
				net = new Run(DB.getScheduler(),prop);
				
				ClassesAllowed.forbidAll();
				ClassesAllowed.allowClass(1);
				ClassesAllowed.allowClass(3);
				
				prop = new PropagationByClassSevere();
				net = new Run(DB.getScheduler(),prop);
				
			}
		}	
	}
		
}
