package network;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Random;

import main.DB;
import network.graph.Edge;
import network.graph.MyGraph;

public class RandomNetworkGenerator {
	
	MyGraph GRand = new MyGraph("AgRandomTest"); //random graph with the same properties of G

	
	public MyGraph getGRand() {
		return GRand;
	}

	public int incrementRandomAgGraph(MyGraph gEvents) { 
		//returns the number of changes
		
		this.GRand.setTime(gEvents.getTime());
		MyGraph gEventsRand = RandomNetworkGenerator.generateERGraph3(gEvents);
		return this.GRand.aggregateGraph(gEventsRand);
		
	}
	
	public static MyGraph generateERGraph(MyGraph graph) {
		
		Random r = new Random();
		
		MyGraph gRand = new MyGraph("Random");

		int v1, v2, indexV1, indexV2, numEdgesER = 0;

		
		int n = graph.getNumNodes();
		int ntries = 0;
		
		ArrayList<Edge> edgeList = new ArrayList<Edge>(graph.getEdgeSet()); 
		
		int nodesERDegree[] = new int[n];
		
		Iterator<Integer> nodesIds = graph.getNodeSet().iterator();
		ArrayList<Integer> currentNodes = new ArrayList<Integer>();

		int i=0;
		
		HashMap<Integer,Integer> idToIdx = new HashMap<Integer,Integer>();
		
		while(nodesIds.hasNext()) {
			int nodeId = nodesIds.next();
			nodesERDegree[i] = graph.getDegree(nodeId);
			gRand.addNode(nodeId);
			idToIdx.put(nodeId, i);
			for(int j=0; j<nodesERDegree[i]; j++) {
				currentNodes.add(nodeId);
				
			}
			i++;
		}
		
		//System.out.println("size: " + currentNodes.size());
		
		while(numEdgesER < graph.getNumEdges() && ntries < 10) {
			indexV1 = r.nextInt(currentNodes.size());
			indexV2 = r.nextInt(currentNodes.size());
			v1 = currentNodes.get(indexV1);
			v2 = currentNodes.get(indexV2);
			int idxV1 = idToIdx.get(v1);
			int idxV2 = idToIdx.get(v2);
			if(v1 != v2 && nodesERDegree[idxV1] > 0 && nodesERDegree[idxV2] > 0) {
				ntries = 0;
				if(!gRand.existsEdge(v1,v2)) {
					Edge e = edgeList.remove(r.nextInt(edgeList.size()));
					gRand.addEdge(v1, v2, e.getWeight(), graph.getTime() + (long)(e.getWeight()*3600));
					numEdgesER+=2;
					nodesERDegree[idxV1]--;
					nodesERDegree[idxV2]--;
					currentNodes.remove(indexV1);
					if(indexV1<indexV2)
						indexV2--;
					currentNodes.remove(indexV2);
				}
				else { //remove random edge
					Edge e = gRand.removeRandomEdge();
					nodesERDegree[idToIdx.get(e.getNodeSrc())]++;
					nodesERDegree[idToIdx.get(e.getNodeDest())]++;
					currentNodes.add(e.getNodeSrc());
					currentNodes.add(e.getNodeDest());
					edgeList.add(e);
				}
			}
			else
				ntries++;
			//else if(graph.getNumEdges() - numEdgesER == 2) return this.generateERGraph(graph);
		}
		
		return gRand;
			
	}	
	
	public static MyGraph generateERGraph2(MyGraph graph) {
		
		Random r = new Random();
		
		MyGraph gRand = new MyGraph("Random");

		ArrayList<Edge> edges = new ArrayList<Edge>(graph.getEdgeSet());
		
		//remove duplicates
		int i=0;
		while(i<edges.size()) {
			Edge e = edges.get(i);
			if(e.getNodeDest() < e.getNodeSrc())
				edges.remove(i);
			else
				i++;
		}
		
		while(edges.size() > 1) {
			int idx1 = r.nextInt(edges.size());
			Edge e1 = edges.remove(idx1);
			
			int idx2 = r.nextInt(edges.size());
			Edge e2 = edges.remove(idx2);
			
/*			int aux = e1.getNodeDest();
			e1.setNodeDest(e2.getNodeDest());
			e2.setNodeDest(aux);*/
			
			gRand.addEdge(e1.getNodeSrc(), e2.getNodeDest());
			gRand.addEdge(e2.getNodeSrc(), e1.getNodeDest());
				

		}
		
		
		return gRand;
			
	}	
	
	public static MyGraph generateERGraph3(MyGraph graph) {
		
		Random r = new Random();
		
		LinkedList<Integer> urnSize = new LinkedList<Integer>();
		for(int j=0; j<100; j++)
			urnSize.add(j);
		
		MyGraph gRand = new MyGraph("Random");
		

		ArrayList<Edge> edges = new ArrayList<Edge>(graph.getEdgeSet());
		ArrayList<Integer> urn = new ArrayList<Integer>();
		ArrayList<Edge> edgeList = new ArrayList<Edge>(graph.getEdgeSet()); 
		
		//remove duplicates
		int i=0;
		while(i<edges.size()) {
			Edge e = edges.get(i);
			if(e.getNodeDest() < e.getNodeSrc())
				edges.remove(i);
			else {
				urn.add(e.getNodeDest());
				urn.add(e.getNodeSrc());
				i++;

			}

		}
		
	
		//while(urn.size() > 0 && urnSize.peekFirst() != urnSize.peekLast()) {
		boolean answer = urnSize.peekFirst() != urnSize.peekLast() && urn.size() > 0;
		while(answer) {
			urnSize.remove();
			
			//System.out.println(urn.size());
			int idx1 = r.nextInt(urn.size());
			int v1 = urn.remove(idx1);
			
			//ArrayList<Integer> availableNodes = (ArrayList<Integer>) urn.clone();
			ArrayList<Integer> availableNodes = urn;
			//availableNodes.removeAll(gRand.getNeighsSet(v1));
			//Integer[] arrayNodes = availableNodes.toArray(new Integer[0]);
			
			int idx2 = r.nextInt(availableNodes.size());
			Integer v2 = availableNodes.get(idx2);
			
			//int idx2 = r.nextInt(urn.size());
			//int v2 = urn.remove(idx2);
			
			if(!gRand.existsEdge(v1, v2) && v1 != v2) {
				
				Edge e = edgeList.remove(r.nextInt(edgeList.size()));
				//gRand.addEdge(v1, v2, e.getWeight(), graph.getTime() + (long)(e.getWeight()*3600));
				//gRand.addEdge(v1, v2, e.getWeight(), ((graph.getTime()-1)*DB.getRecordInterval()+1) + (long)(e.getWeight()*DB.getWeightScale()));
				gRand.addEdge(v1, v2, 1, ((graph.getTime()-1)*DB.getRecordInterval()+1) + 1);				
				
				
				//gRand.addEdge(v1, v2);
				urn.remove(v2);
			}
			else {
				urn.add(v1);
				//urn.add(v2);
			}
				
			urnSize.addLast(urn.size());
			int s1 = urnSize.peekFirst();
			int s2 = urnSize.peekLast();
			answer = (s1 != s2 );
			answer = answer && urn.size() > 0;
		}
		
		
		return gRand;
			
	}	
	
	

}
