package propagation;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Random;
import java.util.Scanner;

import loganalysis.EdgesClassReader;
import main.DB;
import main.RunConfig;

import org.apache.commons.collections15.keyvalue.MultiKey;
import org.apache.commons.math.stat.descriptive.DescriptiveStatistics;

import network.functions.IndividualFunctions;
import network.graph.Edge;
import network.graph.MyGraph;

public class PredictionByClass {
	


	int numContacts = 0;
	int currentHour = 0;
	
	boolean constructG = false;
	int countNewEdgesHighTO = 0;
	int countNewEdgesLowTO = 0;
	HashSet<MultiKey<Integer>> newEdgesHighTO = new HashSet<MultiKey<Integer>>();
	
	
	HashSet<MultiKey<Integer>>[] edgesByClass = new HashSet[DB.NUM_CLASSES+1];
	

	double time, TO;
	
	EdgesClassReader eclasses;
	
	
	public PredictionByClass() {
		this.eclasses = new EdgesClassReader();
		for(int i=0; i<DB.NUM_CLASSES+1; i++) {
			this.edgesByClass[i] = new HashSet<MultiKey<Integer>>();
		}
	}
	

	private void printPredictionScores() {
		System.out.print(this.currentHour);
		for(int i=0; i<=DB.NUM_CLASSES; i++) {
			double pclass = (double)this.edgesByClass[i].size()/this.eclasses.getNumEdgesPerClass(i);
			//String result = i + " " + pclass;
			System.out.print("\t" + pclass);
		}
		System.out.println();
	}
	
	public void saveClassCount() {
		String fileName = DB.getGraphsPath() + "prediction" + DB.getDBName() +  "_start" + DB.getTrainingSetUpperBound() + "_end" + DB.getTestSetUpperBound() + ".dat";
		System.out.println(fileName);
		File file = new File(fileName);
		try {
			FileWriter writer = new FileWriter(file, true);
			PrintWriter out = new PrintWriter(writer);
			System.out.print(RunConfig.P_RANDOM);
			out.print(RunConfig.P_RANDOM);
			for(int i=0; i<=DB.NUM_CLASSES; i++) {
				double pclass = (double)this.edgesByClass[i].size()/this.eclasses.getNumEdgesPerClass(i);
				System.out.print(" " + pclass);
				out.print(" " + pclass);
			}
			out.println();
			System.out.println();
			out.close();
			writer.close();
		} catch(Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
	


	public void processContact(int v1, int v2, long time) throws EveryoneInfectedException {
		
		

		if(v1 < v2) {
			this.numContacts++;
			this.time = time;
			
			if(numContacts == 1)
				this.TO = time;
			int numHours = (int)Math.floor((time - this.TO)/3600.0);
			
			if(numHours > currentHour) {
				//this.printPredictionScores();
				currentHour = numHours;
			}
			
			
	
			int eclass = this.eclasses.getEdgeClass(v1, v2);
			try {
				this.edgesByClass[eclass].add(new MultiKey<Integer>(v1,v2));
			} catch(Exception e) {
				System.out.println(e.getMessage());
			}
		}

					
	}
	
	

}
