package propagation;

import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Random;

import org.apache.commons.math.stat.descriptive.DescriptiveStatistics;

import main.DB;
import main.RunConfig;
import network.graph.Edge;
import network.graph.MyGraph;

public class PropagationAnalyzer {
	
	
	HashSet<Integer> infected = new HashSet<Integer>();
	MyGraph g;
	HashMap<Integer,Long> delays = new HashMap<Integer,Long>();
	
	int firstNode = 0;
	
	
	int totalPeople;
	
	long time, timeFirstInfection, timeLastInfection;
	
	int maxnode = -1;
	
	public PropagationAnalyzer(MyGraph g, int n) {
		this.totalPeople = n;
		this.g = g;
	}
	
	public void infectFirstNode(int v) {
		this.firstNode = v;
		this.infect(v);
	}
	
	public void infectRandomNode() {
        Random r = new Random(2);
        int randomNode = r.nextInt(this.totalPeople);
        System.out.println("FIRST NODE INFECTED: " + randomNode);
        this.firstNode = randomNode;
        infect(this.firstNode);
	}
	
	public void infect(int v) {
		
/*		if(v == 2) {
			//maxnode = v;
			System.out.println(v);
		}*/
			
		
		if(!this.infected.contains(v)) {
			
			this.infected.add(v);
			
			if(this.infected.size() == 2)
				this.timeFirstInfection = this.time;
			
			delays.put(v,this.time - this.timeFirstInfection);
			Edge edges[] = g.getEdges(v);
			if(edges != null) {
				for(int i=0; i<edges.length; i++) {
					if(!this.infected.contains(edges[i].getNodeDest()))
						this.infect(edges[i].getNodeDest());
				}
			}
			
			

			
			if(this.infected.size() == this.totalPeople) {
				this.timeLastInfection = this.time;
				System.out.println("*******Everyone infected! total time: " + (this.timeLastInfection - this.timeFirstInfection)
									+ "\n last node infected: " + v);
			}

		}
			
	}
	
	public double getInfectedPct() {
		return (double)(infected.size())/totalPeople;
	}
	
	public void printDelays() {
		try {
			File file = new File(DB.getFeaturesPath() + "/propagation/results" + RunConfig.RANDOM_EDGES_USE + "-" + RunConfig.RICH_CLUB_USE + "/propagation" + this.firstNode);
			FileWriter writer = new FileWriter(file);
			PrintWriter out = new PrintWriter(writer);
			
			Integer nodes[] = infected.toArray(new Integer[0]);
			
			for(int i=0; i<nodes.length; i++) 
				out.println(nodes[i] + " " + delays.get(nodes[i]));
			
			out.close();
			writer.close();
			
		} catch(Exception e) {
			System.out.println(e.getMessage());
		}
	}
	
	public void processContact(int v1, int v2, long time) {
		this.time = time;
		if(infected.contains(v1)) {
			infect(v2);
		}
		else if(infected.contains(v2)) {
			infect(v1);
		}
	}
	
	

}
