package scheduler;

import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.PriorityQueue;
import java.util.Scanner;

import main.DB;

public class SchedulerNus extends Scheduler {
	
    FileReader fin;
    Scanner src;	
    
    private final Integer BUFFER_SIZE = 50000;
    


    public SchedulerNus(String fileName) throws IOException  {
    	super(fileName);
	    fin = new FileReader(fileName);
	    src = new Scanner(fin);
	    loadContactTrace();
	}

	public void loadContactTrace() throws IOException {
	    Long tIni,  tFin;
	    int sessionId, numUsers, duration;

	    
	    int count = 0;
	    int users[] = new int[10000];
	    while (src.hasNext() && count < BUFFER_SIZE) {
	    	tIni = src.nextLong();
	    	sessionId = src.nextInt();
	    	numUsers = src.nextInt();
	    	duration = src.nextInt();
	    	tFin = tIni + duration;
	    	
	    	//System.out.println(count + ": " + tIni + " " + sessionId + " " + numUsers + " " + duration);
	    	
	    	src.nextLine();
	    	String lineUsers = src.nextLine();
	    	
	    	Scanner src2 = new Scanner(lineUsers);
	    	
	    	int i = 0;
	    	while (src2.hasNext()) {
	    		users[i] = src2.nextInt();
	    		i++;
	    	}
	    	
	    	for (i=0; i<numUsers; i++) {
	    		for(int j=i+1; j<numUsers; j++) {
	    	    	super.addConnection(tIni, users[i], users[j], duration);
	    	    	super.addDisconnection(tFin, users[i], users[j]);
	    	    	count+=2;
	    		}
	    		
	    	}

	    }
	    
	    //System.out.println("done!");
	    
	    if(!src.hasNext()) {
	    	//src.close();
	    	fin.close();
	    }

    
	}
	
		public Event getNextEvent() throws Exception {
		if(schedule.size() < BUFFER_SIZE/10 && src.hasNext())
			loadContactTrace();
		return super.getNextEvent();
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		try {
			SchedulerNus s = new SchedulerNus(DB.getFilePath());
			while(s.hasNextEvent()) {
				//System.out.println(s.getNextEvent());
				System.out.println(s.getNextEvent());
			}
		} catch(Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

	}

}
