package scheduler;

import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;

import main.DB;

public class SchedulerUPB extends Scheduler {
	
    FileReader fin;
    Scanner src;
    
    public SchedulerUPB(String fileName) throws IOException  {
    	super(fileName);
	    fin = new FileReader(fileName);
	    src = new Scanner(fin);
	    super.nodeTable.populateNodeTable(1, 677);
	    
	    loadContactTrace();
	    

	}
    
	public void loadContactTrace() throws IOException {
	    String id1, id2;
	    Long tIni, tFin;


	    while (src.hasNext()) {
	    	
	    	id1 = src.next();
	    	id2 = src.next(); 
	    		
	    	tIni = src.nextLong();
	    	tFin = src.nextLong();
	    	Double weight = (double)(tFin-tIni)/DB.getWeightScale();
	    	
	    	//System.out.println(id1 + " " + id2 + " " + tIni + " " + tFin);
	    	
	    	//if(Integer.parseInt(id2) <= 22) {
	    		super.addConnection(tIni, id1, id2, weight);
	    		super.addDisconnection(tFin, id1, id2);
	    	//}
	    	
	    	try {
	    		src.nextLine();
	    	} catch(java.util.NoSuchElementException nsee) {
	    		System.out.println("End of file...");
	    	}
	    }
	    
	    //System.out.println("done!");
	    
	    if(!src.hasNext()) {
	    	//src.close();
	    	fin.close();
	    }

    
	}
    
    
    

}
